CGC_CaHVA_defs = "CGC_CaHVA.m" ;
autoload ("CGC_CaHVA" , CGC_CaHVA_defs) ;
autoload ("CGC_CaHVA_init" , CGC_CaHVA_defs) ;
CGC_CaHVA_init ;
y0 = CGC_CaHVA_init (-65) ;
global N ;
N = length (y0) ;
function is = CGC_CaHVA_currents_odepkg (y)
  global N ;
  global i_CaHVA ;
  t = y (1) ;
  s = y (2:N+1) ;
  y1 = CGC_CaHVA (t , s) ;
  is = [ t i_CaHVA ] ;
endfunction
function is = CGC_CaHVA_currents_lsode (y)
  global N ;
  global i_CaHVA ;
  t = y (1) ;
  s = y (2:N+1) ;
  y1 = CGC_CaHVA (s , t) ;
  is = [ t i_CaHVA ] ;
endfunction
function ys = CGC_CaHVA_vclamp_run1_odepkg (N , dt , vchold , vchdur , vcbase , vcdur)
  global reltol abstol
  P = odeset ("RelTol" , reltol , "AbsTol" , abstol , "MaxStep" , 1 , "InitialStep" , dt) ;
  t0 = 0.0 ;
  t1 = t0+vchdur ;
  t2 = t1 ;
  t3 = t2+vcdur ;
  t4 = t3 ;
  t5 = t4+vchdur ;
  vinit = vchold ;
  y0 = CGC_CaHVA_init (vinit)
  sol = ode2r (@CGC_CaHVA , [ t0 t1 ] , y0 , P) ;
  ys = [ sol.x sol.y ] ;
  vinit = vcbase ;
  y0 = sol.y (size (sol.y) (1) , :) ' ; y0 (1) = vinit
  sol = ode2r (@CGC_CaHVA , [ t2 t3 ] , y0 , P) ;
  ys = vertcat (ys , [ sol.x sol.y ]) ;
  vinit = vchold ;
  y0 = sol.y (size (sol.y) (1) , :) ' ; y0 (1) = vinit
  sol = ode2r (@CGC_CaHVA , [ t4 t5 ] , y0 , P) ;
  ys = vertcat (ys , [ sol.x sol.y ]) ;
endfunction ;
function ys = CGC_CaHVA_vclamp_run1_lsode (N , dt , vchold , vchdur , vcbase , vcdur)
  global reltol abstol
  lsode_options ("absolute tolerance" , abstol) ;
  lsode_options ("relative tolerance" , reltol) ;
  lsode_options ("integration method" , "bdf") ;
  lsode_options ("initial step size" , dt) ;
  t0 = 0.0 ;
  t1 = t0+vchdur ;
  thold0 = linspace (t0 , t1 , (t1-t0) /dt) ;
  t2 = t1 ;
  t3 = t2+vcdur ;
  tclamp = linspace (t2 , t3 , (t3-t2) /dt) ;
  t4 = t3 ;
  t5 = t4+vchdur ;
  thold1 = linspace (t4 , t5 , (t5-t4) /dt) ;
  vinit = vchold ;
  y0 = CGC_CaHVA_init (vinit)
  y = lsode (@CGC_CaHVA , y0 , thold0) ;
  ys = [ thold0' y ] ;
  vinit = vcbase ;
  y0 = y (size (y) (1) , :) ' ; y0 (1) = vinit
  y = lsode (@CGC_CaHVA , y0 , tclamp) ;
  ys = vertcat (ys , [ tclamp' y ]) ;
  vinit = vchold ;
  y0 = y (size (y) (1) , :) ' ; y0 (1) = vinit
  y = lsode (@CGC_CaHVA , y0 , thold1) ;
  ys = vertcat (ys , [ thold1' y ]) ;
endfunction
function ilog = CGC_CaHVA_vclamp_fn (N , dt , vchold , vchdur , vcbase , vcdur , vcinc , vcsteps)
  vc = vcbase ;
  ys = cell (1 , vcsteps) ;
  for i = 1:vcsteps
    y = CGC_CaHVA_vclamp_run1_lsode (N , dt , vchold , vchdur , vc , vcdur) ;
    ys (i) = y ;
    vc = vc + vcinc ;
  endfor ;
  ilog = cell (vcsteps , 1) ;
  for i = 1:vcsteps
    ilogv = [ ] ;
    n = size (ys {i}) (1) ;
    for j = 1:n
      next = CGC_CaHVA_currents_lsode (ys {i} (j , :)) ;
      ilogv = vertcat (ilogv , next) ;
    endfor ;
    ilog {i} = ilogv ;
  endfor ;
endfunction
global reltol abstol
reltol = 1e-03 ;
abstol = 1e-03 ;
dt = 0.001 ;
## i_CaHVA plot
i_CaHVA_index = 2 ;
global comp307_vchold comp307_vchdur comp307_vcbase comp307_vcbdur comp307_vcinc comp307_vcsteps
CGC_CaHVA_ilog = CGC_CaHVA_vclamp_fn (N , dt , comp307_vchold , comp307_vchdur , comp307_vcbase , comp307_vcbdur , comp307_vcinc , comp307_vcsteps) ;
subplot (1 , 3 , 1) ;
plot (CGC_CaHVA_ilog{1}(:,1) , CGC_CaHVA_ilog{1}(:,i_CaHVA_index) , CGC_CaHVA_ilog{2}(:,1) , CGC_CaHVA_ilog{2}(:,i_CaHVA_index) , CGC_CaHVA_ilog{3}(:,1) , CGC_CaHVA_ilog{3}(:,i_CaHVA_index) , CGC_CaHVA_ilog{4}(:,1) , CGC_CaHVA_ilog{4}(:,i_CaHVA_index) , CGC_CaHVA_ilog{5}(:,1) , CGC_CaHVA_ilog{5}(:,i_CaHVA_index) , CGC_CaHVA_ilog{6}(:,1) , CGC_CaHVA_ilog{6}(:,i_CaHVA_index) , CGC_CaHVA_ilog{7}(:,1) , CGC_CaHVA_ilog{7}(:,i_CaHVA_index) , CGC_CaHVA_ilog{8}(:,1) , CGC_CaHVA_ilog{8}(:,i_CaHVA_index)) ;
CaHVA_log = vertcat ([CGC_CaHVA_ilog{1}(:,1),CGC_CaHVA_ilog{1}(:,i_CaHVA_index)] , [CGC_CaHVA_ilog{2}(:,1),CGC_CaHVA_ilog{2}(:,i_CaHVA_index)] , [CGC_CaHVA_ilog{3}(:,1),CGC_CaHVA_ilog{3}(:,i_CaHVA_index)] , [CGC_CaHVA_ilog{4}(:,1),CGC_CaHVA_ilog{4}(:,i_CaHVA_index)] , [CGC_CaHVA_ilog{5}(:,1),CGC_CaHVA_ilog{5}(:,i_CaHVA_index)] , [CGC_CaHVA_ilog{6}(:,1),CGC_CaHVA_ilog{6}(:,i_CaHVA_index)] , [CGC_CaHVA_ilog{7}(:,1),CGC_CaHVA_ilog{7}(:,i_CaHVA_index)] , [CGC_CaHVA_ilog{8}(:,1),CGC_CaHVA_ilog{8}(:,i_CaHVA_index)]) ;
save -ascii "CaHVA.dat" CaHVA_log ;
