global KCa_m comp209_vcbdur comp209_vchdur comp209_vcsteps comp209_vcinc comp209_vcbase comp209_vchold comp47_e comp47_gbar ik ek ica v cai comp47_Balpha_c fix_celsius Vrest comp209_vcbdur comp47_Kalpha_c comp47_Abeta_c comp47_Bbeta_c comp47_Kbeta_c comp209_vcinc comp47_Q10 comp47_Aalpha_c comp209_vchdur comp209_vcbase comp209_vcsteps comp47_gbar comp47_e comp209_vchold KCa_m_inf KCa_m_tau i_KCa


function dy = CGC_KCa (y, t)
  global KCa_m comp209_vcbdur comp209_vchdur comp209_vcsteps comp209_vcinc comp209_vcbase comp209_vchold comp47_e comp47_gbar ik ek ica v cai comp47_Balpha_c fix_celsius Vrest comp209_vcbdur comp47_Kalpha_c comp47_Abeta_c comp47_Bbeta_c comp47_Kbeta_c comp209_vcinc comp47_Q10 comp47_Aalpha_c comp209_vchdur comp209_vcbase comp209_vcsteps comp47_gbar comp47_e comp209_vchold KCa_m_inf KCa_m_tau i_KCa
  v  =  y(1);
  % rate eq KCa_m
  KCa_m  =  y(2);
  % equation for KCa_m_inf
  KCa_m_inf  =  comp47_alpha_c(v, cai);
  % equation for KCa_m_tau
  KCa_m_tau  =  comp47_beta_c(v, cai);
  dy  =  zeros(length(y), 1);
  % state KCa_m
  dy(2)  =  (KCa_m_inf + -(KCa_m)) / KCa_m_tau;
  i_KCa  =  (comp47_gbar * KCa_m) * (v - comp47_e);
  ik  =  i_KCa;
  dy(1)  =  0.0;


end


function y0 = CGC_KCa_init (Vinit)
  global KCa_m comp209_vcbdur comp209_vchdur comp209_vcsteps comp209_vcinc comp209_vcbase comp209_vchold comp47_e comp47_gbar ik ek ica v cai comp47_Balpha_c fix_celsius Vrest comp209_vcbdur comp47_Kalpha_c comp47_Abeta_c comp47_Bbeta_c comp47_Kbeta_c comp209_vcinc comp47_Q10 comp47_Aalpha_c comp209_vchdur comp209_vcbase comp209_vcsteps comp47_gbar comp47_e comp209_vchold KCa_m_inf KCa_m_tau i_KCa
  y0  =  zeros(2, 1);
  v  =  Vinit;
  y0(1)  =  v;
  comp47_Balpha_c  =  0.0015;
  fix_celsius  =  30.0;
  Vrest  =  -68.0;
  comp209_vcbdur  =  100.0;
  comp47_Kalpha_c  =  -11.765;
  comp47_Abeta_c  =  1.5;
  comp47_Bbeta_c  =  0.00015;
  comp47_Kbeta_c  =  -11.765;
  comp209_vcinc  =  10.0;
  comp47_Q10  =  1.0;
  comp47_Aalpha_c  =  2.5;
  comp209_vchdur  =  30.0;
  comp209_vcbase  =  -69.0;
  comp209_vcsteps  =  8.0;
  comp47_gbar  =  0.004;
  comp47_e  =  -84.69;
  comp209_vchold  =  -71.0;
  KCa_m_inf  =  comp47_alpha_c(v, cai);
  KCa_m_tau  =  comp47_beta_c(v, cai);
  KCa_m  =  (comp47_alpha_c(v, cai)) / (comp47_alpha_c(v, cai) + comp47_beta_c(v, cai));
  y0(2)  =  KCa_m;
  i_KCa  =  (comp47_gbar * KCa_m) * (v - comp47_e);
  ik  =  i_KCa;


end




function retval336 = comp47_alpha_c (v, cai)
  global KCa_m comp209_vcbdur comp209_vchdur comp209_vcsteps comp209_vcinc comp209_vcbase comp209_vchold comp47_e comp47_gbar ik ek ica comp47_Balpha_c fix_celsius Vrest comp209_vcbdur comp47_Kalpha_c comp47_Abeta_c comp47_Bbeta_c comp47_Kbeta_c comp209_vcinc comp47_Q10 comp47_Aalpha_c comp209_vchdur comp209_vcbase comp209_vcsteps comp47_gbar comp47_e comp209_vchold KCa_m_inf KCa_m_tau i_KCa
  retval336  =  (comp47_Q10 * comp47_Aalpha_c) / (1.0 + (comp47_Balpha_c * exp(v / comp47_Kalpha_c)) / cai);
end




function retval337 = comp47_beta_c (v, cai)
  global KCa_m comp209_vcbdur comp209_vchdur comp209_vcsteps comp209_vcinc comp209_vcbase comp209_vchold comp47_e comp47_gbar ik ek ica comp47_Balpha_c fix_celsius Vrest comp209_vcbdur comp47_Kalpha_c comp47_Abeta_c comp47_Bbeta_c comp47_Kbeta_c comp209_vcinc comp47_Q10 comp47_Aalpha_c comp209_vchdur comp209_vcbase comp209_vcsteps comp47_gbar comp47_e comp209_vchold KCa_m_inf KCa_m_tau i_KCa
  retval337  =  (comp47_Q10 * comp47_Abeta_c) / (1.0 + cai / (comp47_Bbeta_c * exp(v / comp47_Kbeta_c)));
end


